e16-config: Remove.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43 else
44 echon="echo"
45 echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56 else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74 done
75 echo " all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87 "
88 for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115 done
116 echo " all done."
117
118 ###--------------------------------------------------------------------------
119 ### Install global configuration.
120
121 echo -n "Installing dotfile configuration:"
122 if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124 else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127 fi
128
129 ## Symlink the various dotfiles into place
130 dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm
133 vimrc mg
134 mailrc signature
135 cgrc tigrc
136 gdbinit
137 guile
138 toprc
139 aspell.conf
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
143 lisp-init.lisp:.eclrc
144 dircolors colordiffrc screenrc cvsrc indent.pro"
145 [ "$xstuff" ] && dotfiles="$dotfiles
146 xinitrc xsession Xdefaults vncrc vncsession
147 fonts.conf
148 putty-defaults:.putty/sessions/Default%20Settings
149 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
150 e-keybindings.cfg:.enlightenment/keybindings.cfg
151 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
152 e16-bindings:.e16/bindings.cfg
153 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
154 jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
155 echo "Installing dotfiles..."
156 for d in $dotfiles; do
157 target=.$d
158 case $d in
159 *:*) target=${d#*:} d=${d%%:*};;
160 esac
161 ft=$HOME$sub/$target
162 dir=${ft%/*}
163 mkdir -p $dir
164 ln -s $here/$d $ft.new
165 mv $ft.new $ft
166 echo " $target"
167 done
168 echo " all done."
169
170 ###--------------------------------------------------------------------------
171 ### Process the Git configuration.
172
173 echo -n "Installing Git configuration:"
174 sed "
175 1i\
176 ### generated by $here/setup; do not edit!\
177
178 /@releasekey@/ s::$(./mdw-conf release-key 481334C2):g
179 /@gitignore@/ s::$(./mdw-conf gitignore $here/gitignore):g
180 " gitconfig >$HOME/.gitconfig.new
181 mv $HOME/.gitconfig.new $HOME/.gitconfig
182 echo " done."
183
184 ###--------------------------------------------------------------------------
185 ### Install useful scripts included in this package.
186
187 scripts="
188 mdw-editor
189 mdw-conf
190 movemail-hack
191 emerge-hack
192 lesspipe.sh
193 start-ssh-agent
194 svnwrap
195 hyperspec"
196 [ "$xstuff" ] && scripts="$scripts
197 xinitcmd
198 xshutdown"
199 echo "Installing scripts..."
200 mkdir -p $HOME$sub/bin
201 for s in $scripts; do
202 ft=$HOME$sub/bin/$s
203 ln -s $here/$s $ft.new
204 mv $ft.new $ft
205 echo " $s"
206 done
207 echo " all done."
208
209 ###--------------------------------------------------------------------------
210 ### Set up the Emacs config.
211
212 $echon "Finding a suitable emacs:$echoc"
213 emacs=no
214 for i in emacs22 emacs21 emacs; do
215 if type -p >/dev/null $i; then
216 emacs=$i
217 break
218 fi
219 done
220 if [ $emacs = no ]; then
221 echo " failed."
222 emacs=:
223 else
224 echo " $emacs."
225 fi
226
227 echo "Installing Emacs packages..."
228 emacspkg="
229 make-regexp
230 ew-hols
231 git git-blame vc-git stgit
232 quilt"
233 for elib in $emacspkg; do
234 $echon " $elib:$echoc"
235 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
236 (progn
237 (setq load-path (nconc load-path (list "~/lib/emacs")))
238 (kill-emacs (condition-case nil
239 (progn (load-library "'"$elib"'") 0)
240 (error 1))))'; then
241 echo " already installed."
242 else
243 $echon " downloading$echoc"
244 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
245 $echon " compiling$echoc"
246 (cd $HOME$sub/lib/emacs;
247 $emacs >/dev/null 2>&1 --no-site-file --batch \
248 --eval '(byte-compile-file "'"$elib.el"'")')
249 echo " done."
250 fi
251 done
252 echo " all done."
253
254 $echon "Setting up Emacs configuration:$echoc"
255 $echon " linking$echoc"
256 for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
257 set -- $(echo $link | tr : ' ')
258 from=$1 to=$2
259 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
260 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
261 done
262 $echon " compiling$echoc"
263 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
264 echo " done."
265
266 ###----- That's all, folks --------------------------------------------------